
local player
local position
local item
local direction
local task = 0

-- Checks if it is possible to create a building and creates it
local function build()
	if player.can_place_entity{name = item, position = position} then
		if player.surface.can_fast_replace{name = item, position = position, direction = direction, force = "player"} then
			if player.surface.create_entity{name = item, position = position, direction = direction, force="player", fast_replace=true, player=player} then
				state = state - 1
				player.remove_item({name = item, count = 1})
				return true
			end
		else
			if player.surface.create_entity{name = item, position = position, direction = direction} then
				player.remove_item({name = item, count = 1})
				return true
			end
		end
	else 
		game.print(string.format("Build: %s cannot be placed", item:gsub("-", " "):gsub("^%l", string.upper)))
	end
end

-- Main per-tick event handler
script.on_event(defines.events.on_tick, function(event)

    if not player then 
		player = game.players[1]
		position = player.position
		destination = {x = position.x, y = position.y}
		player.force.research_queue_enabled = true
	end

	item = "steam-engine"

	if player.get_item_count(item) == 0 then
		player.insert({name=item, count=1})
	end

	position = {4.500000, 11.500000}
	direction = defines.direction.east

	if task == 0 then
		if build() then
			task = 1
		end
	end

	if task == 1 then
		game.print("placing second steam engine")
		position = {4.500000, 8.500000}
		direction = defines.direction.east
		if build() then
			task = 2
		end
	end
end)

-- Skips the freeplay intro
script.on_event(defines.events.on_game_created_from_scenario, function()

	remote.call("freeplay", "set_skip_intro", true)

end)